<template>
  <div class="c-form-control" :class="error ? 'error' : ''">
    <div class="c-form-control__wrapper">
      <label v-if="label" :for="id" class="c-form-control__header">
        <Paragraph :text="label" weight="semibold" />
        <Required v-if="required && !isPreview" />
      </label>
      <div class="c-form-control__body">
        <slot />
      </div>
    </div>
    <ErrorMessage v-if="error" :text="error" />
  </div>
</template>

<script>
import Paragraph from "@/components/ui/Paragraph";
import Required from "../Required";
import ErrorMessage from "../ErrorMessage";
import { isPreviewMixin } from "../../mixins/isPreview";
export default {
  name: "FormControl",
  components: { ErrorMessage, Required, Paragraph },
  mixins: [isPreviewMixin],
  props: {
    id: {
      type: String
    },
    label: String,
    error: String,
    required: {
      type: Boolean,
      default: true
    }
  }
};
</script>

<style lang="scss">
.c-form-control {
  margin-bottom: 1.25rem;

  &.label-left {
    @include breakpoint(overPhone) {
      .c-form-control__wrapper {
        display: flex;
        flex-wrap: wrap;
        align-items: center;
      }
      .c-form-control__header {
        margin-right: 1rem;
        margin-bottom: 0;
        width: 6.5rem;
      }
      .c-form-control__body {
        flex: 1;
      }
      .c-error {
        width: 100%;
        flex: 1;
        margin-left: 7.5rem;
      }
    }
  }

  &.error {
    input,
    textarea,
    select,
    .v-select {
      border-color: $c-error;
    }
  }

  &__header {
    display: flex;
    margin-bottom: 0.2rem;

    .c-paragraph {
      margin-bottom: 0;
    }
  }
}
</style>
